﻿using System;

namespace ConsoleApplication1
{
    /*
    class Mammal
    {
        public void Move()
        {
            Console.WriteLine("이동한다.");
        }
    }
    class Lion : Mammal
    {
        public void Move()
        {
            Console.WriteLine("네 발로 움직인다.");
        }
    }

    class Whale : Mammal
    {
        public void Move()
        {
            Console.WriteLine("수영한다.");
        }
    }

    class Human : Mammal
    {
        public void Move()
        {
            Console.WriteLine("두 발로 움직인다.");
        }
    }
    */

    class Mammal
    {
        virtual public void Move()
        {
            Console.WriteLine("이동한다.");
        }
    }

    class Lion : Mammal
    {
        override public void Move()
        {
            Console.WriteLine("네 발로 움직인다.");
        }
    }

    class Whale : Mammal
    {
        override public void Move()
        {
            Console.WriteLine("수영한다.");
        }
    }

    class Human : Mammal
    {
        override public void Move()
        {
            Console.WriteLine("두 발로 움직인다.");
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            /*
            Mammal one = new Mammal();
            one.Move();

            Lion lion = new Lion();
            lion.Move();

            Whale whale = new Whale();
            whale.Move();

            Human human = new Human();
            human.Move();


            Lion lion2 = new Lion();
            Mammal one2 = lion2; // 부모 타입으로 형변환

            one2.Move();
            */


            Lion lion = new Lion();
            Mammal one = lion; // 부모 타입으로 형변환
            one.Move();

            Human human = new Human();
            Mammal two = human;
            two.Move();
        }
    }
}
